/* Generated file, do not edit! */

#include "fragmentShader.glsl.h"

char const* const fragmentShader_glsl = 
   "/* Copyright (c) 2007-2011, Maxim Makhinya  <maxmah@gmail.com>\n"
   " *\n"
   " * Redistribution and use in source and binary forms, with or without\n"
   " * modification, are permitted provided that the following conditions are met:\n"
   " *\n"
   " * - Redistributions of source code must retain the above copyright notice, this\n"
   " *   list of conditions and the following disclaimer.\n"
   " * - Redistributions in binary form must reproduce the above copyright notice,\n"
   " *   this list of conditions and the following disclaimer in the documentation\n"
   " *   and/or other materials provided with the distribution.\n"
   " * - Neither the name of Eyescale Software GmbH nor the names of its\n"
   " *   contributors may be used to endorse or promote products derived from this\n"
   " *   software without specific prior written permission.\n"
   " *\n"
   " * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\"\n"
   " * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\n"
   " * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\n"
   " * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE\n"
   " * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR\n"
   " * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF\n"
   " * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS\n"
   " * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN\n"
   " * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)\n"
   " * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE\n"
   " * POSSIBILITY OF SUCH DAMAGE.\n"
   " */\n"
   "// input variables to function\n"
   "uniform sampler3D volume; //gx, gy, gz, v\n"
   "uniform sampler2D preInt; // r,  g,  b, a\n"
   "uniform float shininess;\n"
   "uniform int   normalsQuality;\n"
   "uniform vec3  viewVec;\n"
   "uniform vec3  sizeVec;\n"
   "uniform vec4  taint; // .rgb should be pre-multiplied with .a\n"
   "void main (void)\n"
   "{\n"
   "// Normals\n"
   "    vec3 coords = (gl_TexCoord[0].xyz+gl_TexCoord[1].xyz)/2.0;\n"
   "    vec3 lookupMP;\n"
   "if( sizeVec.x > 0.5 )\n"
   "{\n"
   "    lookupMP = texture3D( volume, coords ).rgb - 0.5;\n"
   "}\n"
   "else\n"
   "{\n"
   "// basic\n"
   "    lookupMP = vec3(\n"
   "        texture3D( volume, coords + vec3( sizeVec.x,0.0,0.0) ).a -\n"
   "        texture3D( volume, coords + vec3(-sizeVec.x,0.0,0.0) ).a,\n"
   "        texture3D( volume, coords + vec3(0.0, sizeVec.y,0.0) ).a -\n"
   "        texture3D( volume, coords + vec3(0.0,-sizeVec.y,0.0) ).a,\n"
   "        texture3D( volume, coords + vec3(0.0,0.0, sizeVec.z) ).a -\n"
   "        texture3D( volume, coords + vec3(0.0,0.0,-sizeVec.z) ).a ) * 6.0;\n"
   "// medium\n"
   "    if( normalsQuality < 2 )\n"
   "    {\n"
   "        float lu = texture3D( volume, coords + vec3(-sizeVec.x, sizeVec.y,0.0) ).a;\n"
   "        float ld = texture3D( volume, coords + vec3(-sizeVec.x,-sizeVec.y,0.0) ).a;\n"
   "        float lb = texture3D( volume, coords + vec3(-sizeVec.x,0.0,-sizeVec.z) ).a;\n"
   "        float lf = texture3D( volume, coords + vec3(-sizeVec.x,0.0, sizeVec.z) ).a;\n"
   "        float ru = texture3D( volume, coords + vec3( sizeVec.x, sizeVec.y,0.0) ).a;\n"
   "        float rd = texture3D( volume, coords + vec3( sizeVec.x,-sizeVec.y,0.0) ).a;\n"
   "        float rb = texture3D( volume, coords + vec3( sizeVec.x,0.0,-sizeVec.z) ).a;\n"
   "        float rf = texture3D( volume, coords + vec3( sizeVec.x,0.0, sizeVec.z) ).a;\n"
   "        float ub = texture3D( volume, coords + vec3(0.0, sizeVec.y,-sizeVec.z) ).a;\n"
   "        float uf = texture3D( volume, coords + vec3(0.0, sizeVec.y, sizeVec.z) ).a;\n"
   "        float db = texture3D( volume, coords + vec3(0.0,-sizeVec.y,-sizeVec.z) ).a;\n"
   "        float df = texture3D( volume, coords + vec3(0.0,-sizeVec.y, sizeVec.z) ).a;\n"
   "        lookupMP += vec3(\n"
   "            ru + rd + rb + rf - lu - ld - lb - lf,\n"
   "            lu + ru + ub + uf - ld - rd - db - df,\n"
   "            lf + rf + uf + df - lb - rb - ub - db ) * 3.0;\n"
   "    }\n"
   "// full\n"
   "    if( normalsQuality < 1 )\n"
   "    {\n"
   "        float lub = texture3D( volume, coords + vec3(-sizeVec.x, sizeVec.y,-sizeVec.z) ).a;\n"
   "        float luf = texture3D( volume, coords + vec3(-sizeVec.x, sizeVec.y, sizeVec.z) ).a;\n"
   "        float ldb = texture3D( volume, coords + vec3(-sizeVec.x,-sizeVec.y,-sizeVec.z) ).a;\n"
   "        float ldf = texture3D( volume, coords + vec3(-sizeVec.x,-sizeVec.y, sizeVec.z) ).a;\n"
   "        float rub = texture3D( volume, coords + vec3( sizeVec.x, sizeVec.y,-sizeVec.z) ).a;\n"
   "        float ruf = texture3D( volume, coords + vec3( sizeVec.x, sizeVec.y, sizeVec.z) ).a;\n"
   "        float rdb = texture3D( volume, coords + vec3( sizeVec.x,-sizeVec.y,-sizeVec.z) ).a;\n"
   "        float rdf = texture3D( volume, coords + vec3( sizeVec.x,-sizeVec.y, sizeVec.z) ).a;\n"
   "        lookupMP += vec3(\n"
   "            lub + luf + ldb + ldf - rub - ruf - rdb - rdf,\n"
   "            lub + luf + rub + ruf - ldb - ldf - rdb - rdf,\n"
   "            luf + ldf + ruf + rdf - lub - ldb - rub - rdb );\n"
   "    }\n"
   "}\n"
   "// Preintegration (colors)\n"
   "    float lookupSF = texture3D(volume, gl_TexCoord[0].xyz).a;\n"
   "    float lookupSB = texture3D(volume, gl_TexCoord[1].xyz).a;\n"
   "    vec4 preInt_ = texture2D(preInt, vec2(lookupSF, lookupSB));\n"
   "    if( taint.a != 0.0 )\n"
   "        preInt_ = vec4( preInt_.rgb*(1.0-taint.a) + \n"
   "                        taint.rgb*taint.a*(-log(preInt_.a)),\n"
   "                        preInt_.a );\n"
   "    // lighting\n"
   "    vec3 tnorm = -normalize( lookupMP );\n"
   "    vec3 lightVec = normalize( gl_LightSource[0].position.xyz );\n"
   "    vec3 reflect  = reflect( -lightVec, tnorm );\n"
   "    float diffuse = max( dot(lightVec, tnorm), 0.0 );\n"
   "    float specular = pow(max(dot(reflect, viewVec), 0.0), shininess);\n"
   "    vec4 color = vec4(gl_LightSource[0].ambient.rgb  * preInt_.rgb +\n"
   "                      gl_LightSource[0].diffuse.rgb  * preInt_.rgb * diffuse +\n"
   "                      gl_LightSource[0].specular.rgb * preInt_.rgb * specular,\n"
   "                      preInt_.a);\n"
   "    gl_FragColor = color;\n"
   "}\n"
   ;
